<?php
/**
 *
 *
 * @package Knowledgeroot
 * @author Frank Habermann
 * @version $Id: class-mysqli.php 260 2006-12-15 23:39:27Z lordlamer $
 */

$KNOWLEDGEROOTDB = 'MYSQL';

class db {
	var $connection = "";
	var $dbtype = "mysqli";
	var $dbname = "mysql";
	var $lastquery = "";
	var $querys = 0;
	var $query_cache = array();
	
	/**
	 *
	 */
	function connect($host,$user,$pass,$db,$schema="",$encoding="") {
		$this->connection = mysqli_connect($host,$user,$pass,$db);
		if(!$this->connection) {
			echo "Cannnot connect to host!\n";
			exit();
		}
		
		/* not needed
		$conndb = mysqli_select_db($db);
		if(!$conndb) {
			echo "Wrong Database!\n";
			exit();
		}
		*/

		return 1;
	}

	/**
	 *
	 */
	function close() {
		mysqli_close($this->connection);
	}

	/**
	 *
	 */
	function lo_import($file) {
		return 1;
	}

	/**
	 *
	 */
	function query($query) {
		$this->lastquery = $query;
		$this->query_cache[] = $query;
		$this->querys += 1;
		
		$res = mysqli_query($this->connection, $query);

		if($res === false) {
			//echo "Error in QUERY: \"" . $this->error . "\"<br>\n";
			echo "ERROR IN QUERY: \"$query\"<br>\n";
		}

		return $res;
	}
	
	/**
	 *
	 */
	function num_rows($result) {
		$anz = mysqli_num_rows($result);
		return $anz;
	}
	
	/**
	 *
	 */
	function fetch_object($result) {
		$row = mysqli_fetch_object($result);
		return $row;
	}

	/**
	 *
	 */
	function fetch_row($result) {
		$row = mysqli_fetch_row($result);
		return $row;
	}

	/**
	 *
	 */
	function fetch_assoc($result) {
		$row = mysqli_fetch_assoc($result);
		return $row;
	}

	/**
	 *
	 */
	function affected_rows($result) {
		$anz = mysqli_affected_rows($result);
		return $anz;
	}

	/**
	 *
	 */
	function error() {
		return mysqli_error;
	}
	
	/**
	 *
	 */
	function last_id($name = "") {
		return mysqli_insert_id();
	}

	/**
	 * create database insert with array
	 *
	 * @param string $table
	 * @param array $values
	 */
	function db_insert($table, $values) {
		if($table != "" && is_array($values)) {
			$sql = "INSERT INTO `" . $table . "` ";

			$coloum = "(";
			$coloumval = "(";

			foreach($values as $key => $value) {
				if(isset($values[$key]['value'])) {
					$coloum .= "`" . $key . "`, ";
					
					if(isset($values[$key]['type'])) {
						switch($values[$key]['type']) {
						case "integer":
						case "INTEGER":
							if(isset($values[$key]['format'])) {
								$coloumval .= sprintf($values[$key]['format'].", ",$values[$key]['value']);
							} else {
								$coloumval .= sprintf("%d, ",$values[$key]['value']);
							}
							break;
						case "float":
						case "FLOAT":
							if(isset($values[$key]['format'])) {
								$coloumval .= sprintf($values[$key]['format'].", ",$values[$key]['value']);
							} else {
								$coloumval .= sprintf("%f, ",$values[$key]['value']);
							}
							break;
						default:
							if(isset($values[$key]['format'])) {
								$coloumval .= sprintf($values[$key]['format'].", ",$values[$key]['value']);
							} else {
								$coloumval .= sprintf("'%s', ",$values[$key]['value']);
							}
						}
					} else {
						$coloumval .= sprintf("'%s', ",$values[$key]['value']);
					}
				}
			}

			// remove last comma
			$coloum = substr($coloum,0,strlen($coloum)-2);
			$coloumval = substr($coloumval,0,strlen($coloumval)-2);

			$coloum .= ")";
			$coloumval .= ")";

			$sql .= $coloum . " VALUES " . $coloumval;

			return $this->query($sql);
		} else {
			return 0;
		}
	}

	/**
	 * create database update with array
	 *
	 * @param string $table
	 * @param array $values
	 * @param string $where
	 */
	function db_update($table, $values, $where) {
		if($table != "" && is_array($values)) {
			$sql = "UPDATE `" . $table . "` SET ";

			$coloum = "";

			foreach($values as $key => $value) {
				if(isset($values[$key]['value'])) {
					if(isset($values[$key]['type'])) {
						switch($values[$key]['type']) {
						case "integer":
						case "INTEGER":
							if(isset($values[$key]['format'])) {
								$coloum .= sprintf("`%s`=".$values[$key]['format'].", ",$key,$values[$key]['value']);
							} else {
								$coloum .= sprintf("`%s`=%d, ",$key,$values[$key]['value']);
							}
							break;
						case "float":
						case "FLOAT":
							if(isset($values[$key]['format'])) {
								$coloum .= sprintf("`%s`=".$values[$key]['format'].", ",$key,$values[$key]['value']);
							} else {
								$coloum .= sprintf("`%s`=%f, ",$key,$values[$key]['value']);
							}
							break;
						default:
							if(isset($values[$key]['format'])) {
								$coloum .= sprintf("`%s`='".$values[$key]['format']."', ",$key,$values[$key]['value']);
							} else {
								$coloum .= sprintf("`%s`='%s', ",$key,$values[$key]['value']);
							}
						}
					} else {
						$coloum .= sprintf("`%s`='%s'",$key,$values[$key]['value']);
					}
				}
			}

			// remove last comma
			$coloum = substr($coloum,0,strlen($coloum)-2);

			if($where == "") $where = "1";
			
			$sql .= $coloum . " WHERE " . $where;
			
			return $this->query($sql);
		} else {
			return 0;
		}
	}
	
	/**
	 * create a database delete
	 *
	 * @param string $table
	 * @param string $where
	 */
	function db_delete($table, $where) {
		if($table != "") {
			$sql = "DELETE FROM `".$table."`";
			
			if($where != "") {
				$sql .= " WHERE " . $where;
			}
			
			return $this->query($sql);
		} else {
			return 0;
		}
	}
}

?>