<?php
/**
 *
 *
 * @package Knowledgeroot
 * @author Frank Habermann
 * @version $Id: class-pgsql.php 261 2006-12-24 00:17:28Z lordlamer $
 */

$KNOWLEDGEROOTDB = 'PGSQL';

class db {
	var $connection = "";
	var $dbtype = "pgsql";
	var $dbname = "postgresql";
	var $lastquery = "";
	var $querys = 0;
	var $query_cache = array();

	/**
	 *
	 */
	function connect($host,$user,$pass,$db,$schema="public",$encoding="LATIN1") {
		$this->connection = pg_connect("host=$host dbname=$db user=$user password=$pass");
		$this->schema($schema);
		$this->set_client_encoding($encoding);
		
		return 1;
	}
	
	function _connect($constr) {
		return pg_connect($constr);
	}

	/**
	 *
	 */
	function close() {
		if(!pg_close($this->connection)) {
			print "Failed to close connection to " . pg_host($this->connection) . ": " . pg_last_error($this->connection) . "<br/>\n";
		} else {
			//print "Successfully disconnected from database";
		}
	}

	/**
	 *
	 */
	function schema($schema = "") {
		if($schema != "") {
			$res = $this->query("SET search_path TO ".$schema);
			return $res;
		}

		return 1;
	}

	/**
	 *
	 */
	function set_client_encoding($encoding = "") {
		if($encoding != "") {
			return pg_set_client_encoding($this->connection, $encoding);
		}

		return 0;
	}

	/**
	 *
	 */
	function query($query) {
		$this->lastquery = $query;
		$this->query_cache[] = $query;
		$this->querys += 1;

		$res = pg_query($this->connection, $query);

		// if error in query
		if($res === false) {
			echo $query;
		}

		return $res;
	}

	/**
	 *
	 */
	function num_rows($result) {
		$anz = pg_num_rows($result);
		return $anz;
	}

	/**
	 *
	 */
	function fetch_object($result) {
		$row = pg_fetch_object($result);
		return $row;
	}

	/**
	 *
	 */
	function fetch_row($result) {
		$row = pg_fetch_row($result);
		return $row;
	}

	/**
	 *
	 */
	function fetch_assoc($result) {
		$row = pg_fetch_assoc($result);
		return $row;
	}

	/**
	 *
	 */
	function affected_rows($result) {
		$anz = pg_affected_rows($this->connection, $result);
		return $anz;
	}

	/**
	 *
	 */
	function error() {
		return pg_last_error($this->connection);
	}

	/**
	 *
	 */
	function lo_open($oid,$mode) {
		return pg_lo_open($this->connection,$oid,$mode);
	}

	/**
	 *
	 */
	function lo_close($handle) {
		return pg_lo_close($handle);
	}

	/**
	 *
	 */
	function lo_read_all($handle) {
		return pg_lo_read_all($handle);
	}

	/**
	 *
	 */
	function lo_create() {
		return pg_lo_create($this->connection);
	}

	/**
	 *
	 */
	function lo_write($handle,$buffer) {
		return pg_lo_write($handle,$buffer);
	}

	/**
	 *
	 */
	function lo_unlink($oid) {
		return pg_lo_unlink($this->connection,$oid);
	}

	/**
	 *
	 */
	function last_id($name) {
		$res = $this->query("select last_value FROM $name");
		$row = $this->fetch_assoc($res);

		return $row['last_value'];
	}

	/**
	 * create database insert with array
	 *
	 * @param string $table
	 * @param array $values
	 */
	function db_insert($table, $values) {
		if($table != "" && is_array($values)) {
			$sql = "INSERT INTO \"" . $table . "\" ";

			$coloum = "(";
			$coloumval = "(";

			foreach($values as $key => $value) {
				if(isset($values[$key]['value'])) {
					$coloum .= "\"" . $key . "\", ";
					
					if(isset($values[$key]['type'])) {
						switch($values[$key]['type']) {
						case "integer":
						case "INTEGER":
							if(isset($values[$key]['format'])) {
								$coloumval .= sprintf($values[$key]['format'].", ",$values[$key]['value']);
							} else {
								$coloumval .= sprintf("%d, ",$values[$key]['value']);
							}
							break;
						case "float":
						case "FLOAT":
							if(isset($values[$key]['format'])) {
								$coloumval .= sprintf($values[$key]['format'].", ",$values[$key]['value']);
							} else {
								$coloumval .= sprintf("%f, ",$values[$key]['value']);
							}
							break;
						default:
							if(isset($values[$key]['format'])) {
								$coloumval .= sprintf("'".$values[$key]['format']."', ",$values[$key]['value']);
							} else {
								$coloumval .= sprintf("'%s', ",$values[$key]['value']);
							}
						}
					} else {
						$coloumval .= sprintf("'%s', ",$values[$key]['value']);
					}
				}
			}

			// remove last comma
			$coloum = substr($coloum,0,strlen($coloum)-2);
			$coloumval = substr($coloumval,0,strlen($coloumval)-2);

			$coloum .= ")";
			$coloumval .= ")";

			$sql .= $coloum . " VALUES " . $coloumval;

			return $this->query($sql);
		} else {
			return 0;
		}
	}

	/**
	 * create database update with array
	 *
	 * @param string $table
	 * @param array $values
	 * @param string $where
	 */
	function db_update($table, $values, $where) {
		if($table != "" && is_array($values)) {
			$sql = "UPDATE \"" . $table . "\" SET ";

			$coloum = "";

			foreach($values as $key => $value) {
				if(isset($values[$key]['value'])) {
					if(isset($values[$key]['type'])) {
						switch($values[$key]['type']) {
						case "integer":
						case "INTEGER":
							if(isset($values[$key]['format'])) {
								$coloum .= sprintf("\"%s\"=".$values[$key]['format'].", ",$key,$values[$key]['value']);
							} else {
								$coloum .= sprintf("\"%s\"=%d, ",$key,$values[$key]['value']);
							}
							break;
						case "float":
						case "FLOAT":
							if(isset($values[$key]['format'])) {
								$coloum .= sprintf("\"%s\"=".$values[$key]['format'].", ",$key,$values[$key]['value']);
							} else {
								$coloum .= sprintf("\"%s\"=%f, ",$key,$values[$key]['value']);
							}
							break;
						default:
							if(isset($values[$key]['format'])) {
								$coloum .= sprintf("\"%s\"=".$values[$key]['format'].", ",$key,$values[$key]['value']);
							} else {
								$coloum .= sprintf("\"%s\"='%s', ",$key,$values[$key]['value']);
							}
						}
					} else {
						$coloum .= sprintf("\"%s\"='%s'",$key,$values[$key]['value']);
					}
				}
			}

			// remove last comma
			$coloum = substr($coloum,0,strlen($coloum)-2);

			if($where == "") $where = "1";
			
			$sql .= $coloum . " WHERE " . $where;
			
			return $this->query($sql);
		} else {
			return 0;
		}
	}
	
	/**
	 * create a database delete
	 *
	 * @param string $table
	 * @param string $where
	 */
	function db_delete($table, $where) {
		if($table != "") {
			$sql = "DELETE FROM \"".$table."\"";
			
			if($where != "") {
				$sql .= " WHERE " . $where;
			}
			
			return $this->query($sql);
		} else {
			return 0;
		}
	}
}

?>